/* 
 * This package contains all of the components, transactions and sequences
 * related to the mem_agent.  Import this package if you need to use anything
 * the mem_agent anywhere.
 */

`include "ovm_macros.svh"

package mem_agent_pkg;

   import ovm_pkg::*;
   import ovm_container_pkg::*;

   //Typedef used by the mem_agent
   typedef enum bit[1:0]  {READ, WRITE, PAUSE} instruction_type;

   //Include the sequence_items (transactions)
`include "mem_item.svh"

   //Include the agent config object
`include "mem_config.svh"

   //Include the components
`include "mem_driver.svh"
`include "mem_monitor.svh"
`include "mem_agent.svh"

   //Include the sequences
`include "mem_seq_base.svh"
`include "mem_seq1.svh"
`include "mem_seq2.svh"
`include "mem_seq3.svh"
`include "mem_seq4.svh"
`include "mem_seq5.svh"
`include "mem_seq6.svh"
   

endpackage : mem_agent_pkg
   
