class mem_seq3_c extends mem_seq_base_c;

   const string report_id = "MEM_SEQ3";
   
   mem_item_latency4_change_c mem_item_latency4_change_h;
   mem_item_latency2_change_c mem_item_latency2_change_h;
   mem_item_latency6_change_c mem_item_latency6_change_h;

   `ovm_object_utils(mem_seq3_c)
   
   function new(string name = "mem_seq3_c");
      super.new(name);
   endfunction : new
   
   task body();
      
      repeat (10) begin
         //Have the factory create a mem_item object
         m_mem_item_h = mem_item_latency4_change_c::type_id::create("mem_item_latency4_change_c");
         start_item(m_mem_item_h);  //calls wait_for_grant();
         //Need to randomize here (Scenarios randomize in the apply method)
         assert(m_mem_item_h.randomize());
         //`ovm_info(report_id, "m_mem_item_h.convert2string()", OVM_LOW);
         `ovm_info(report_id, m_mem_item_h.convert2string(), OVM_LOW);
         /*`ovm_info(report_id, "m_mem_item_h.sprint()", OVM_LOW);
         `ovm_info(report_id, m_mem_item_h.sprint(), OVM_LOW);
         `ovm_info(report_id, "m_mem_item_h.print()", OVM_LOW);
         m_mem_item_h.print();*/
         finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
      end
      repeat (10) begin
         //Have the factory create a mem_item object
         m_mem_item_h = mem_item_latency2_change_c::type_id::create("mem_item_latency2_change_c");
         start_item(m_mem_item_h);  //calls wait_for_grant();
         //Need to randomize here (Scenarios randomize in the apply method)
         assert(m_mem_item_h.randomize());
         `ovm_info(report_id, m_mem_item_h.convert2string(), OVM_LOW);
         finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
      end
      repeat (10) begin
         //Have the factory create a mem_item object
         m_mem_item_h = mem_item_latency6_change_c::type_id::create("mem_item_latency6_change_c");
         start_item(m_mem_item_h);  //calls wait_for_grant();
         //Need to randomize here (Scenarios randomize in the apply method)
         assert(m_mem_item_h.randomize());
         `ovm_info(report_id, m_mem_item_h.convert2string(), OVM_LOW);
         finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
      end

   endtask : body

endclass : mem_seq3_c

