class mem_seq5_c extends mem_seq_base_c;

   const string report_id = "MEM_SEQ5";

   `ovm_object_utils(mem_seq5_c)
   
   function new(string name = "mem_seq5_c");
      super.new(name);
   endfunction : new
   
   task body();
      repeat (2000) begin
         //Have the factory create a stimulus object
         m_mem_item_h = mem_item_c::type_id::create("mem_item_c");
         start_item(m_mem_item_h);  //calls wait_for_grant();
         //Need to randomize here (Mem_seqs randomize in the apply method)
         assert(m_mem_item_h.randomize() with {instruction == WRITE;});
         `ovm_info(report_id, m_mem_item_h.convert2string(),OVM_LOW )
         finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
      end
      
      repeat (2000) begin
         //Have the factory create a stimulus object
         m_mem_item_h = mem_item_c::type_id::create("mem_item_c");
         start_item(m_mem_item_h);  //calls wait_for_grant();
         //Need to randomize here (Mem_seqs randomize in the apply method)
         assert(m_mem_item_h.randomize() with {instruction == READ;});
         `ovm_info(report_id, m_mem_item_h.convert2string(),OVM_LOW )
         finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
      end
      
   endtask : body

endclass : mem_seq5_c

