class mem_seq6_c extends mem_seq_base_c;

   const string report_id = "MEM_SEQ6";

   //Mem_seqs
   mem_seq1_c        mem_seq1_h;
   mem_seq5_c        mem_seq5_h;
   //Transaction
   mem_item_c         m_mem_item_h;

   `ovm_object_utils(mem_seq6_c)
   
   function new(string name = "mem_seq6_c");
      super.new(name);

      mem_seq1_h = new("mem_seq1_h");
      mem_seq5_h = new("mem_seq5_h");
   endfunction : new
   
   task body();
      //Let's start the mem_seqs one after another.  You could also start
      // them in parallel using a fork join.
      // m_sequencer is the pointer to the sequencer that comes
      // from the ovm_sequence class
      `ovm_info(report_id, "Starting Mem_seq 1",OVM_LOW )
      mem_seq1_h.start(m_sequencer, this);
      
      `ovm_info(report_id, "Starting Mem_seq 5",OVM_LOW )
      mem_seq5_h.start(m_sequencer, this);
      
      `ovm_info(report_id, "Finish with a Pause",OVM_LOW )
      //Have the factory create a stimulus object
      m_mem_item_h = mem_item_c::type_id::create("mem_item_c");
      start_item(m_mem_item_h);  //calls wait_for_grant();
      //Need to randomize here (Scenarios randomize in the apply method)
      assert(m_mem_item_h.randomize() with {instruction == PAUSE;});
      finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
   endtask : body

endclass : mem_seq6_c

