//////////////////////////////////////////////////////////////////////////////
// analysis_group_c - Groups together all the analysis pieces of the testbench
//////////////////////////////////////////////////////////////////////////////
class analysis_group_c extends ovm_component;

   string report_id = "ANALYSIS_GROUP";

   ovm_analysis_export   #(mem_item_c)  analysis_export;

   coverage_c                           coverage_h;
   scoreboard_c                         scoreboard_h;

   //Register with the Factory
   `ovm_component_utils(analysis_group_c)

   function new(string name, ovm_component parent);
      super.new(name, parent);
   endfunction : new

   function void build();
      super.build();
      //Create the coverage and scoreboard objects
      coverage_h   = coverage_c::type_id::create("coverage_h", this);
      scoreboard_h = scoreboard_c::type_id::create("scoreboard_h", this);

      //New the analysis export
      if (analysis_export == null)
        analysis_export = new("analysis_export", this);
   endfunction : build

   function void connect();
      //Connect the analysis_export to the coverage and scoreboard objects
      analysis_export.connect(coverage_h.analysis_export);
      analysis_export.connect(scoreboard_h.analysis_export);

   endfunction :  connect


endclass : analysis_group_c
