//////////////////////////////////////////////////////////////////////////////
// test3 - A mem sequence based test using mem_seq3.
//////////////////////////////////////////////////////////////////////////////
class test3 extends test_base_c;

   const string report_id = "TEST3";
   
   `ovm_component_utils(test3)

   function new(string name = "test3", ovm_component parent = null);
      super.new(name, parent);
   endfunction : new

   function void build();
      //Set any type overrides before building the environment with super.build
      //Pick Mem Sequece 3
      mem_seq_base_c::type_id::set_type_override(mem_seq3_c::get_type());
      
      //Build the config objects
      m_mem_cfg_h = mem_config_c::type_id::create("m_mem_cfg_h");

      //Set the config values
      configure_mem(m_mem_cfg_h, "test3");  //Defined in test_base

      //Put the config objects into the config space
      set_config_object("*mem_agent_h*", "mem_config", m_mem_cfg_h, .clone(0));

      //Builds the environment and mem sequence
      super.build();
   endfunction : build
   
   task run();
      //Start the mem sequence
      ovm_test_done.raise_objection(this);
      m_mem_seq_h.start(m_mem_sequencer_h); //This task call is blocking
      //drop_objection() automatically calls global_stop_request() when all
      // objections are dropped
      ovm_test_done.drop_objection(this); 
   endtask : run
   
endclass : test3
